package cz.muni.fi.pb162.firetrucks;

import java.lang.reflect.Constructor;
import java.lang.reflect.Field;
import java.lang.reflect.Method;
import java.lang.reflect.Modifier;
import junit.framework.TestCase;

public class AbstractFireTruckTest extends junit.framework.TestCase
{
    public AbstractFireTruckTest(String testName) {
        super(testName);
    }
    
    public void testMethodsAndAttributes() {
        BasicRulesTester.testMethodsAndAttributes(AbstractFireTruck.class);
    }
    
    public void testCrewAttribute() {
        Field field = null;
        try {
            field = AbstractFireTruck.class.getDeclaredField("crew");
        } catch (NoSuchFieldException ex) {
            fail("Trida AbstractFireTruck neobsahje atribut crew");
        }
        assertTrue("Atriut crew neni private",
                Modifier.isPrivate(field.getModifiers()));
    }
    
    public void testConstructor() {
        Constructor constructor = null;
        try {
            constructor = AbstractFireTruck.class.getDeclaredConstructor(int.class);
        } catch (NoSuchMethodException ex) {
            fail("Trida AbstractFireTruck nema pozadovany konstruktor");
        }
        assertTrue("Trida AbstractFireTruck obsahuje nejaky zbytecny " +
                "konstruktor navic", AbstractFireTruck.class.
                getDeclaredConstructors().length == 1);
    }
    
    public void testGetCrew() {
        String msg = "Metoda getCrew() nevraci hodnotu, ktera byla predana " +
                "jako parametr konstruktoru (chyba muze byt bud v konstruktoru," +
                "nebo v metode getCrew())";
        
        AbstractFireTruck instance = new AbstractFireTruckImpl(3);
        assertEquals(msg,3, instance.getCrew());
    }
    
    public void testRequiredForFireAccidents() {
        Method method = null;
        try {
            method = AbstractFireTruck.class.getMethod("requiredForFireAccidents");
        } catch (NoSuchMethodException ex) {
            fail("Trida nema metodu requiredForFireAccidents()");
        }
        assertTrue("Metoda requiredForFireAccidents() ve tride AbstractFireTruck by mela " +
                "byt abstraktni",
                Modifier.isAbstract(method.getModifiers()) || 
                !method.getDeclaringClass()
                .equals(AbstractFireTruck.class));
    }

    public void testRequiredForTrafficAccidents() {
        Method method = null;
        try {
            method = AbstractFireTruck.class.getMethod("requiredForTrafficAccidents");
        } catch (NoSuchMethodException ex) {
            fail("Trida nema metodu requiredForTrafficAccidents()");
        }
        assertTrue("Metoda requiredForTrafficAccidents() ve tride AbstractFireTruck by mela " +
                "byt abstraktni",
                Modifier.isAbstract(method.getModifiers()) || 
                !method.getDeclaringClass()
                .equals(AbstractFireTruck.class));
    }

    public void testToString() {
        Method toStringMethod = null;
        try {
            toStringMethod = AbstractFireTruck.class.getMethod("toString");
        } catch (NoSuchMethodException ex) {
            fail("Trida nema metodu toString - to by nikdy nemelo nastat");
        }
        assertTrue("Metoda toString() ve tride AbstractFireTruck by mela " +
                "byt abstraktni nebo nebyt definovana",
                Modifier.isAbstract(toStringMethod.getModifiers()) || 
                !toStringMethod.getDeclaringClass()
                .equals(AbstractFireTruck.class));
    }
    
    private class AbstractFireTruckImpl extends AbstractFireTruck {

        AbstractFireTruckImpl(int c) {
            super(c);
        }
        
        public boolean requiredForFireAccidents() {
            throw new UnsupportedOperationException();
        }

        public boolean requiredForTrafficAccidents() {
            throw new UnsupportedOperationException();
        }

        public String toString() {
            throw new UnsupportedOperationException();
        }
    }
}
