package cz.muni.fi.pb162.firetrucks;


/**
 * This interface represents a crash fire truck,
 * i.e. the truck used mainly by rescue teams for traffic accidents.
 * 
 * These trucks are sent automatically to traffic accidents.
 * These trucks are sent to fire accidents only if necessary (occasionally).
 *
 * @author Radek Oslejsek
 * @version 2007-10-12
 */
public interface CrashTruck extends TankTruck 
{
    /**
     * Returns name of the wrecking device.
     * 
     * @return name of the wrecking device.
     */
    String getWreckingDeviceName();
    
    /**
     * Returns name of the generator.
     * 
     * @return name of the generator
     */
    String getGeneratorName();
}
