package cz.muni.fi.pb162.firetrucks;

/**
 * This interface represents a fire truck, i.e. any kind of a vehicles
 * used by fire fighters in their job.
 *
 * @author Radek Oslejsek
 * @version 2007-10-12
 */
public interface FireTruck 
{    
    /**
     * Returns number of crew members.
     * 
     * @return number of crew members
     */
    int getCrew();
    
    /**
     * Informs, whether this truck is automatically sent to fire accidents. 
     * 
     * @return true if this truck is sent to fire accidents automatically,
     *         false if this truck is sent to fire accidents accasionally
     */
    boolean requiredForFireAccidents();
    
    /**
     * Informs, whether this truck is automatically sent to traffic accidents 
     * (e.g car crashes). 
     * 
     * @return true if this truck is sent to traffic accidents automatically,
     *         false if this truck is sentto traffic accidents accasionally
     */
    boolean requiredForTrafficAccidents();
            
    /**
     * Returns text description of the truck.
     * 
     * @return text description of the truck
     */
    String toString();
}
