package cz.muni.fi.pb162.firetrucks;

/**
 * This interface represents a tank fire truck, 
 * i.e. a fire truck carying water.
 * 
 * These trucks are sent automatically to fire accidents.
 * These trucks are sent to traffic accidents only if necessary (occasionally).
 *
 * @author Radek Oslejsek
 * @version 2007-10-12
 */
public interface TankTruck extends FireTruck 
{
    /**
     * Returns capacity of the water tank in litres.
     * 
     * @return capacity of the watertank in litres.
     */
    int getTankCapacity();
    
    /**
     * Returns pump output in litres per minute.
     * 
     * @return pump output in litres per minute
     */
    int getPumpOutput();    
    
    /**
     * Returns minimal period of jetting in minutes.
     * 
     * @return minimal period of jetting in minutes.
     */
    int getMinJettingPeriod();
}
